unit mgEfeito;

interface

uses windows, messages, sysutils, mmsystem,
     dvcrt, dvwin, dvform, dvarq, dvwav,mgefeitoSox,
     mgMsg, mgVars, grAmost, ShellApi;

procedure menuEfeito;
procedure fadeIn;
procedure fadeOut;
procedure sobeVolume;
procedure desceVolume;
procedure aplicaSenha;
procedure ajudaEfeito;
procedure MenuAdiciona (msg: string);
function selSetasEfeitos: char;

implementation

{--------------------------------------------------------}
{        Executa o efeito passado como parmetro
{--------------------------------------------------------}

procedure SalvaTemporario;
var
    c: char;
begin
    mensagem('MGSALVARA',1); {  'Deseja manter o efeito?(S/N)'  }
        repeat
            c := Readkey;
            case upcase(c) of
                ESC,'N':
                begin
                    mensagem('MGNAO',2); {  No  }
                    som.leArquivo(arqTemp1);
                end;

                'S', ENTER:
                        mensagem('MGSIM',2); {  Sim  }
            end;
        until (upcase(c) = 'N') or (upcase(c) = 'S') or (c = ESC) or (c = ENTER);
    limpaBaixo(8);
end;

{--------------------------------------------------------}

procedure fadeIn;
var inicio, fim: integer;
begin
    inicio := 0;
    fim := cursor;

    som.rampa (inicio, fim, 0.0, 1.0);

    mensagem ('MGFADEINA', 1);  {'FadeIn adicionado'}
    mensagem('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;

end;

{--------------------------------------------------------}

procedure fadeOut;
var inicio, fim: integer;
begin
    inicio := cursor;
    fim := som.numAmostras-1;

    som.rampa (inicio, fim, 1.0, 0.0);
    mensagem ('MGFADEOUT', 1);  {'FadeOut adicionado'}
    mensagem('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;

end;

{--------------------------------------------------------}

procedure adicionaEco;
var
    a, b: TStereo16;
    i, n, dist: integer;
    fator1_eco, fator2_eco: real;

begin
    fator1_eco := fator_eco / 100.0;
    fator2_eco := 1.0 - fator1_eco;

    with som do
        begin
            dist := (velocidade div 11025) * dist_eco;
            n := numAmostras+dist;
            amostra [n-1] := SILENCIO;   // precria area de silencio no fim
            for i := n-1 downto 0 do
                begin
                     a := amostra[i];
                     b := amostra [i-dist];
                     // nota: o objeto som retorna silncio para acessos a ndices < 0
                     a.left  := trunc(a.left  * fator1_eco) + trunc(b.left  * fator2_eco);
                     a.right := trunc(a.right * fator1_eco) + trunc(b.right * fator2_eco);
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGECO', 1);  {'Eco adicionado'}
    mensagem ('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;

end;

{--------------------------------------------------------}

procedure adicionaReverber;
var
    a, b: TStereo16;
    i, n, dist: integer;
    fator1_reverb, fator2_reverb: real;

begin
    fator1_reverb := fator_reverb / 100.0;
    fator2_reverb := 1.0 - fator1_reverb;
    with som do
        begin
            dist := (velocidade div 11025) * dist_reverb;
            n := numAmostras+dist;
            amostra [n-1] := SILENCIO;   // precria area de silencio no fim
            for i := 0 to n-1 do
                begin
                     a := amostra[i];
                     b := amostra [i-dist];
                     a.left  := trunc(a.left  * fator1_reverb) + trunc(b.left  * fator2_reverb);
                     a.right := trunc(a.right * fator1_reverb) + trunc(b.right * fator2_reverb);
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGREV', 1);  {'Reverberao adicionada'}
    mensagem('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;    
end;

{--------------------------------------------------------}

procedure desceVolume;
begin
    som.rampa(0, som.numAmostras-1, 0.75, 0.75);
    mensagem ('MGVOLDIM', 1);  {'Diminu o volume em 25 por cento'}
    mensagem('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;
end;

{--------------------------------------------------------}

procedure sobeVolume;
begin
    som.rampa(0, som.numAmostras-1, 8.75, 8.75);
    mensagem ('MGVOLAUM', 1);  {'Aumentei o volume em 25 por cento'}
    mensagem('MGDEMONS',0);  { 'Demonstrao: '  }
    while sintFalando do waitMessage;
    som.tocaTudo;
    SalvaTemporario;
end;

{--------------------------------------------------------}

procedure aplicaSenha;
var i: integer;
    a: TStereo16;
    senha: array [0..255] of byte;
    salva: word;
    x: smallInt;
    s: string;
    erro: integer;
begin
    mensagem ('MGDIGSEN', 0);   {'Digite a senha com 6 digitos: '}
    salva := textAttr;
    textAttr := 0;
    readln (s);
    textAttr := salva;

    if s = '' then
        begin
            mensagem ('MGDESIST', 1);  {'Desistiu'}
            exit;
        end;

    val (s, x, erro);

    senha[0] := 17 xor (x and 255) xor ((x shr 5) and 255);
    for i := 1 to 255 do
        senha [i] := (senha[i-1] * 13 + 89) mod 255;

    with som do
        begin
            for i := 0 to numAmostras-1 do
                begin
                     a := amostra[i];
                     x := smallInt (word (senha[i and $ff]) shl 8);
                     a.left   := a.left  xor x;
                     a.right  := a.right xor x;
                     amostra[i] := a;
                end;
        end;

    mensagem ('MGSENHAP', 1);  {'Senha aplicada'}
end;

{--------------------------------------------------------}

procedure ajudaEfeito;
begin
    textBackground (RED);
    mensagem ('MGASOPC',2); {'As opes so:'}
    textBackground (BLACK);
    writeln;

    mensagem ('MGVOLSOB', 1);  {'+ - Aumenta Volume'}
    mensagem ('MGVOLDES', 1);  {'- - Diminui volume'}
    mensagem ('MGFADEIN', 1);  {'I - Fade In'}
    mensagem ('MGFADEOU', 1);  {'O - Fade Out'}
    mensagem ('MGCODSEN', 1);  {'P - Codifica com senha}
    mensagem ('MGOPECO',  1);  {'E - Eco'}
    mensagem ('MGOPCXE',  1);  {'X - Super Eco'}
    mensagem ('MGOPREV',  1);  {'R - Reverbera'}
    mensagem ('MGOPSREV', 1);  {'S - Super Reverber'}
    mensagem ('MGVOLTSO', 1);  {'T - Inverte o som'}
    mensagem ('MGTREBL',  1);  {'A - Agudos'}
    mensagem ('MG_BASS',  1);  {'G - Graves'}
    mensagem ('MGSPEED',  1);  {'V - Velocidade'}
    mensagem ('MGPITCH',  1);  {'F - Altera frequncia'}
    mensagem ('MGOPCEQ',  1);  {'Q - Equalizao por faixas'}
    mensagem ('MG_NORM',  1);  {'N - Normaliza Volume'}

end;

{--------------------------------------------------------}

    procedure MenuAdiciona (msg: string);
    begin
        popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasEfeitos: char;
var n: integer;

const
    nopc = 16;
    tabLetrasOpcoes: string [nopc] = '+-iopexrstagvfqn';

begin

    garanteEspacoTela(nopc);

    popupMenuCria (wherex, wherey, 27, nopc, MAGENTA);

    menuAdiciona ('MGVOLSOB');    {'+ - Aumenta Volume'}
    menuAdiciona ('MGVOLDES');    {'- - Diminui volume'}
    menuAdiciona ('MGFADEIN');    {'I - Fade In'}
    menuAdiciona ('MGFADEOU');    {'O - Fade Out'}
    menuAdiciona ('MGCODSEN');    {'P - Codifica com senha}
    menuAdiciona ('MGOPECO');     {'E - Eco'}
    menuAdiciona ('MGOPCXE');     {'X - Super Eco'}
    menuAdiciona ('MGOPREV');     {'R - Reverber'}
    menuAdiciona ('MGOPSREV');    {'S - Super Reverber'}
    menuAdiciona ('MGVOLTSO');    {'T - Inverte o som'}
    menuAdiciona ('MGTREBL');     {'A - Agudos'}
    menuAdiciona ('MG_BASS');     {'G - Graves'}
    menuAdiciona ('MGSPEED');     {'V - Velocidade'}
    menuAdiciona ('MGPITCH');     {'F - Altera frequncia'}
    menuAdiciona ('MGOPCEQ');     {'Q - Equalizao por faixas'    }
    menuAdiciona ('MG_NORM');     {'N - Normaliza Volume'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= nopc) then
        selSetasEfeitos := tabLetrasOpcoes[n]
    else
        selSetasEfeitos := ESC;
end;

{--------------------------------------------------------}
{               ciclo de processamento geral
{--------------------------------------------------------}

procedure menuEfeito;
var
    processando: boolean;
    c, c2: char;
label executa;
begin
    processando := true;
    while processando do
        begin
            Som.gravaArquivo(Arqtemp1);
            while keypressed do readkey;
            limpabaixo(wherey);
            textBackground (BLUE);
            mensagem ('MGOPEF', 0);   {'Qual efeito? '}
            textBackground (BLACK);

            sintLeTecla (c, c2);
            writeln;

            if c = #$0 then
                begin
                    if c2 = F1 then
                        ajudaEfeito
                    else
                    if (c2 = CIMA) or (c2 = BAIX) then
                        begin
                            c := selSetasEfeitos;
                            goto executa;
                        end
                end
            else
               begin
        executa:
                    case upcase(c) of
                        '+':  sobeVolume;
                        '-':  desceVolume;
                        'I':  fadeIn;
                        'O':  fadeOut;
                        'E':  adicionaEco;
                        'R':  adicionaReverber;
                        'P':  aplicaSenha;

                        'T':  efeitoSox('reverse');    //retrgado
                        'S':  efeitoSox('reverb');    //Reverberao
                        'F':  efeitoSox('pitch');     //afinao
                        'V':  efeitoSox('speed');     //velocidade
                        'G':  efeitoSox('bass');      //grave
                        'A':  efeitoSox('treble');    //agudo
                        'N':  efeitoSox('norm');      //normaliza volume
                        'Q':  efeitoSox('equalizer'); //equalizador de faixas de frequncia
                        'X':  efeitoSox('echo');      //eco

                        ESC: processando := false;
                    else
                        mensagem ('MGOPINV', 2); {'Opo invlida, F1 ajuda'}
                    end;
                end;
        end;
end;

end.
